> For the complete documentation index, see [llms.txt](https://docs.hiero.org/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.hiero.org/block-node-overview/block-node-hardware-specifications/quickstart.md).

# Local Development Quickstart

## Table of Contents

1. [Configuration](#configuration)
2. [Running locally](#running-locally)
   1. [Build the Server](#build-the-server)
   2. [Run the Server](#run-the-server)
   3. [Run the Server with Debug](#run-the-server-with-debug)
   4. [Stop the Server](#stop-the-server)

## Configuration

Refer to the [Configuration](https://github.com/hiero-ledger/hiero-docs/tree/master/block-node/configuration.md) for configuration options.

## Running locally

* Server subproject qualifier: `:app`
* Assuming your working directory is the repo root

> **NOTE:** one may use the `-p` flag for `./gradlew` in order to avoid specifying the target subproject repeatedly on each task when running multiple tasks. When running only a single task, however, it is recommended to use the project qualifier (i.e. `:app:`) for both simplicity and clarity.

### Build the Server

> **NOTE:** if you have not done so already, it is generally recommended to build the entire repo first:
>
> ```bash
> ./gradlew clean build -x test
> ```

1. To quickly build the Server sources (without running tests), do the following:

   ```bash
   ./gradlew clean build -x test
   ```
2. Before building the server ensure your tests run successfully:

   ```bash
   ./gradlew clean qualityGate build runSuites
   ```
3. To build the Server docker image, do the following:

   ```bash
   ./gradlew :app:createDockerImage
   ```

### Run the Server

1. To start the Server, do the following:

   ```bash
   ./gradlew :app:startDockerContainer
   ```

### Run the Server with Debug

1. To start the Server with debug enabled, do the following:

   ```bash
   ./gradlew :app:startDockerDebugContainer
   ```
2. Attach your remote jvm debugger to port 5005.

### Stop the Server

1. To stop the Server do the following:

   ```bash
   ./gradlew :app:stopDockerContainer
   ```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.hiero.org/block-node-overview/block-node-hardware-specifications/quickstart.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
